#include "DxLib.h"
#include "TLS.h"

void ENEMY::Init(int dtype,float dmyx,float dmyy,float dmySpeed,float dmydeg,float dmyflame,bool dmyflg)
{
	switch(dtype)
	{
	case RED:
		Handle=ENEMYIMG[RED]; 
		break;
	case BLUE:
		Handle=ENEMYIMG[BLUE]; 
		break;
	case GREEN:
		Handle=ENEMYIMG[GREEN]; 
		break;
	case VIOLET:
		Handle=ENEMYIMG[VIOLET]; 
		break;
	case YELLOW:
		Handle=ENEMYIMG[YELLOW]; 
		break;
	case SBLUE:
		Handle=ENEMYIMG[SBLUE];
		break;
	}
	type=defotype=dtype;
	x=dx=cx=dmyx;
	y=dy=cy=dmyy;
	Speed=dmySpeed;
	deg=ddeg=(float)(dmydeg*M_PI/180.0);
	flame=dflame=dmyflame;
	flg=dflg=dmyflg;
}

void ENEMY::ChangeBullet(int dtype)
{
	switch(dtype)
	{
	case RED:
		Handle=ENEMYIMG[RED]; 
		break;
	case BLUE:
		Handle=ENEMYIMG[BLUE]; 
		break;
	case GREEN:
		Handle=ENEMYIMG[GREEN]; 
		break;
	case VIOLET:
		Handle=ENEMYIMG[VIOLET];
		cx=x;
		cy=y;
		break;
	case YELLOW:
		Handle=ENEMYIMG[YELLOW]; 
		break;
	case SBLUE:
		Handle=ENEMYIMG[SBLUE]; 
		break;
	}
	type=dtype;
}

void ENEMY::Reset()
{
	x=cx=dx;
	y=cy=dy;
	deg=ddeg;
	flame=dflame;
	flg=dflg;
	ChangeBullet(defotype);
}

void ENEMY::ResetFlame(float nflame){flame=nflame;}

void ENEMY::Move()
{
	if(type==VIOLET){deg=atan2(Me_y-cy,Me_x-cx);}
	oldx[0]=x;
	oldy[0]=y;
	oldx[1]=x+cos(deg)*Speed;
	oldy[1]=y+sin(deg)*Speed;
	oldx[2]=oldx[1]+cos(deg)*Speed;
	oldy[2]=oldy[1]-sin(deg)*Speed;
	y+=sin(deg)*Speed;
	x+=cos(deg)*Speed;
	if(x<-80)
	{
		flame=-1;
	}
	if((y<50 || y>460) && x>ME_START_X && flg==TRUE) //˕Ԃe͎eɕς
	{
		ChangeBullet(VIOLET);
		flg=FALSE;
	}
}

float ENEMY::Ret_x(void){return x;}

float ENEMY::Ret_y(void){return y;}

int ENEMY::Ret_Type(void){return type;}

int ENEMY::Ret_size_X(void){return Extendx;}

int ENEMY::Ret_size_Y(void){return Extendy;}

bool ENEMY::OutCheck(float cnt,float x,float y)
{
	if(cnt-flame<1.0){Me_x=x;Me_y=y;}
	if(flg==TRUE &&(y<50+10 || y>470-10)){Me_x=x;Me_y=y;}
	if(cnt>flame && flame>0)
		return TRUE;
	else
		return FALSE;
}

void ENEMY::Out()
{
	switch(type)
	{
	case RED:
		Extendx=Extendy=40;
		break;
	case BLUE:
		Extendx=Extendy=20;
		break;
	case GREEN:
		Extendx=Extendy=12;
		break;
	case VIOLET:
		Extendx=Extendy=20;
		break;
	case YELLOW:
		Extendx=60;
		Extendy=12;
		break;
	case SBLUE:
		Extendx=200;
		Extendy=5;
		break;
	}
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,255);    //uhȂ
	DrawExtendGraph((int)x,(int)y,(int)(x+Extendx),(int)(y+Extendy),Handle ,TRUE);
	return;
}